# (c) 2000  STMicroelectronics ******************************
#
#PROJECT : EkeyUdisk
#
#VERSION :  V 1.2
#
#CREATION DATE :  11/03/2004
#
#AUTHOR : #	MCU Competence Center / ST Shanghai
#
#-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
#
#
#************************* EXECUTABLE COMMAND DEFINES *************************/

ENV = 	default.env
CC  =   $(COMP) -DTHUMB_DRIVE -DMP3_PFD -DONE_PARTITION $(FLAGS)

#************************** OBJECT FILES DEFINES ******************************

OBJ_LIST   =	descript.o Appli.o MAL_Func.o ui.o \
		main.o map_7265.o Int_7265.o \
		usb_ep1.o usb_ep2.o usb_lib.o usb_int.o \
		User_lib.o BOT.o MSL.o RBC.o \
		MAL.o MAL_init.o MAL_2K.o MAL_Map.o \
		DTC_Func.o 2K_DTC.o 2K_Mass.o NewEcc2K.o HID_usb.o UARTT0.o\

#******************************************************************************
EkeyUdisk.abs : 	$(ENV) $(OBJ_LIST) EkeyUdisk.prm
		$(LINK) EkeyUdisk.prm
#******************************************************************************


# -----------------------
# APPLI			--------------------------------------------------------
# -----------------------

Appli.o :	$(ENV) Appli.c Appli.h descript.h NAND.h
			$(CC) Appli.c

descript.o :	$(ENV) descript.c descript.h
			$(CC) descript.c

ui.o :		$(ENV) ui.c Appli.h descript.h
			$(CC) ui.c

MAL_Func.o:	MAL_Func.c MAL_Func.h MConfig.h
	$(CC) MAL_Func.c


# -----------------------
# MAIN ---------------------------------------------------------------
# -----------------------

main.o :	$(ENV) main.c main.c map_7265.h MAL_Func.h NAND.h
			$(CC) main.c

# -----------------------
# MICRO			--------------------------------------------------------
# -----------------------

map_7265.o :	$(ENV) map_7265.c CondComp.h map_7265.h
				$(CC) map_7265.c

Int_7265.o :	$(ENV) Int_7265.c Int_7265.h CondComp.h hidef.h descript.h MAL_Func.h NAND.h HID_usb.h
			$(CC) Int_7265.c



usb_lib.o: usb_lib.c usb_reg.h usb_def.h usb_app.h usb_libs.h mcu_conf.h map_7265.h
	$(CC) usb_lib.c

usb_int.o: usb_int.c usb_reg.h usb_def.h usb_app.h usb_lib.h usb_libs.h mcu_conf.h map_7265.h
	$(CC) usb_int.c

usb_ep1.o: usb_ep1.c usb_reg.h usb_def.h usb_app.h usb_lib.h mcu_conf.h map_7265.h
	$(CC) usb_ep1.c

usb_ep2.o: usb_ep2.c usb_reg.h usb_def.h usb_app.h usb_lib.h mcu_conf.h map_7265.h
	$(CC) usb_ep2.c



# -----------------------
# MICRO			--------------------------------------------------------
# -----------------------

User_lib.o :	$(ENV) User_lib.c User_lib.h CondComp.h hidef.h descript.h
				$(CC) User_lib.c


# -----------------------
# CLASS LAYER     --------------------------------------------------------------
# -----------------------

BOT.o :		$(ENV) BOT.c BOT.h CondComp.h hidef.h descript.h SenseDat.h \
		User_lib.h
	$(CC) BOT.c

MSL.o:		$(ENV) MSL.c
	$(CC) MSL.c

RBC.o :		$(ENV) RBC.c RBC.h CondComp.h hidef.h descript.h SenseDat.h \
		User_lib.h
	$(CC) RBC.c

# -----------------------
# MAL LAYER     ----------------------------------------------------------------
# -----------------------
MAL.o: MAL.c MSL.h MAL.h MAL_Func.h MConfig.h NAND.h
	$(CC) MAL.c

MAL_init.o:	MAL_init.c MAL_Map.h
	$(CC) MAL_init.c

MAL_2K.o:	MAL_2K.c MConfig.h MSL.h MAL_Map.h MAL.h 2K_Mass.h DTC_Func.h NAND.h
	$(CC) MAL_2K.c

MAL_Map.o:	MAL_Map.c
	$(CC) MAL_Map.c

# -----------------------
# DTC LAYER     ----------------------------------------------------------------
# -----------------------

DTC_Func.o:	$(ENV) DTC_Func.c Map_7265.h MAL_Map.h DTC_Func.h
	$(CC) DTC_Func.c

2K_DTC.o:	$(ENV) 2K_DTC.c smc_dtc_code0_end.hex smc_dtc_download_end.hex \
		smc_dtc_upload_end.hex smc_dtc_format_end.hex \
		smc_dtc_mapzone_end.hex smc_dtc_play_end.hex
	$(CC) 2K_DTC.c

2K_Mass.o:	$(ENV) 2K_Mass.c Map_7265.h MAL_Map.h MAL_2K.h \
		2K_Mass.h DTC_Func.h 2K_DTC.h MAL.h Mconfig.h
	$(CC) 2K_Mass.c

NewEcc2K.o:	$(ENV) NewEcc2K.c Map_7265.h MAL_Map.h 2K_Mass.h
	$(CC) NewEcc2K.c

HID_usb.o: $(ENV) HID_usb.c HID_usb.h usb_lib.h Descript.h mcu_conf.h usb_def.h UARTT0.h
	$(CC) HID_usb.c


UARTT0.o: UARTT0.c UARTT0.h Map_7265.h HID_usb.h DTC_Func.h
	$(CC) UARTT0.c

#********** (c) 2000   STMicroelectronics *************** END OF FILE *********

