/************************************************************************************
************************************************************************************/

#pragma DATA_SEG SHORT CRD_BIT_RAM
extern unsigned char CrdFlags;
extern unsigned char CardDataNum;

extern void CardSend(unsigned int, unsigned char* );
extern void CardReceive(unsigned char*);
extern void CardPowerOn(void);
extern void Crd_Initiate(void);
extern void StartReceiveETUCount(void);
extern void StartSendETUCount(void);
extern void StopETUCount(void);
extern void Delay1Etu(void);
extern void Delay165(void);


#define ResetSmartCard { PCDR &= ~0x20; Delay1Etu(); Delay165(); PCDR |= 0x20; }

#define SetPC4Interrupt	{ PCDDR &= ~0x10; PCOR |= 0x10; }
#define SetPC4Input	{ PCDDR &= ~0x10; PCOR &= ~0x10; }
#define SetPC4Output	{ PCDDR |= 0x10;	PCOR &= ~0x10; }

// RST line keep low at least 400 card clock (800 Fcpu)

#define		CommunicateEndFlag	0x01
#define   CardSendFlag				0x02				// to distinguish send or receive operation

#define		bCommunicateEndFlag		(CrdFlags & CommunicateEndFlag) 
#define		Set_bCommunicateEndFlag		(CrdFlags |= CommunicateEndFlag)
#define		Reset_bCommunicateEndFlag	(CrdFlags &= (~CommunicateEndFlag))

#define		bCardSendFlag			(CrdFlags & CardSendFlag) 
#define		Set_bCardSendFlag		(CrdFlags |= CardSendFlag)
#define		Reset_bCardSendFlag		(CrdFlags &= (~CardSendFlag))