#include "MSL.h"


#pragma CONST_SEG CLASS_ROM
/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
const char Page83_Inquiry_Data[] = {							// Device identification page
	0x0E,
	0x83,
	0x00,
	0x25,
	0x02, 0x01, 0x00, 0x02,
	'U', 'S', 'B', ' ', 'M', 'a', 's', 's',						// 8: Vendor_Identification[8]
	' ', 'S', 't', 'o', 'r', 'a', 'g', 'e',
	' ', 'd', 'e', 'v', 'i', 'c', 'e', ' ',						// 16: Product_Identification[16]
	' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ' 		// Serial number
};  

/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
const char Page80_Inquiry_Data[] = {							// Unit serial number page
	0x0E,
	0x80,
	0x00,
	0x0C,
	'S', 'T', '7', '2', '6', '5',  '-', '2', '0', '0', '2'
}; 

/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
const char Standard_Inquiry_Data[] = {
/*	0x0E,
	0x80,
	0x04,
	0x02,
	0x5B,
	0x00,
	0x00,
	0x00,
*/	0x00,
	0x80,
	0x02,
	0x02,
	0x5B,
	0x00,
	0x00,
	0x00,
	'U', 'S', 'B', ' ', 'M', 'a', 's', 's',						// 8: Vendor_Identification[8]
	' ', 'S', 't', 'o', 'r', 'a', 'g', 'e',
	' ', 'd', 'e', 'v', 'i', 'c', 'e', ' ',						// 16: Product_Identification[16]
	' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',				// 32: Procuct_Revision_Level[4]
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,		// 36: Vendor_Specific[20]
	0x00,
	0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,					// 58: WORD Version_descriptor[8]
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,		// 74: Reserved[22]
	0x00, 0x00
}; 

/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
const char MODE_SENSE6_data[MODE_SENSE6_LEN] = {
	0x03,	0x00,	0x00,	0x00
};	

const char MODE_SENSE10_data[MODE_SENSE10_LEN] = {
	0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* Do not use the following data unless you know the meaning
const char MODE_SENSE6_data[MODE_SENSE6_LEN] = {
	0x37,	0x00,	0x00,	0x08,
	0x00,	0x00,	0xFA,	0x00,	0x00,	0x00,	0x02,	0x00,
	0x01,	0x0A,	0x80,	0x10,	0x00,	0x00,	0x00,	0x00,
	0x02,	0x00,	0x00,	0x00,
	0x05,	0x1E,	0x0F,	0xA0,	0x08,	0x10,	0x02,	0x00,
	0x01,	0xF4,	0x00,	0x00,	0x00,	0x00,	0x00,	0x00,
	0x00,	0x00,	0x00,	0x00,	0x00,	0x00,	0x00,	0x00,
	0x00,	0x00,	0x00,	0x00,	0x00,	0x00,	0x00,	0x00
};	

const char MODE_SENSE10_data[MODE_SENSE10_LEN] = {
	0x00, 0x3A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00
};
*/

const char READ_FORMAT_CAPACITIES_data[READ_FORMAT_CAPACITIES_LEN] = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x7F, 0x02, 0x00, 0x02, 0x00
};